WrappedSyntaxView
Date: 2017-02-11

org.fife.ui.rsyntaxtextarea

## Class WrappedSyntaxView

- java.lang.Object
- - javax.swing.text.View
  - - javax.swing.text.CompositeView
    - - javax.swing.text.BoxView
      - - org.fife.ui.rsyntaxtextarea.WrappedSyntaxView

- All Implemented Interfaces:
    javax.swing.SwingConstants, javax.swing.text.TabExpander

      public class WrappedSyntaxView
      extends javax.swing.text.BoxView
      implements javax.swing.text.TabExpander

  The view used by `RSyntaxTextArea` when word wrap is enabled.

- - ### Field Summary

    - ### Fields inherited from class javax.swing.text.View

      `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

    - ### Fields inherited from interface javax.swing.SwingConstants

      `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WrappedSyntaxView(javax.swing.text.Element elem)` Creates a new WrappedSyntaxView.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `calculateBreakPosition(int p0, Token tokenList, float x0)` This is called by the nested wrapped line views to determine the break location.
    `void` | `changedUpdate(javax.swing.event.DocumentEvent e, java.awt.Shape a, javax.swing.text.ViewFactory f)` Gives notification from the document that attributes were changed in a location that this view is responsible for.
    `protected void` | `drawView(org.fife.ui.rsyntaxtextarea.TokenPainter painter, java.awt.Graphics2D g, java.awt.Rectangle r, javax.swing.text.View view, int fontHeight, int y, int line)` Draws a single view (i.e., a line of text for a wrapped view), wrapping the text onto multiple lines if necessary.
    `protected void` | `drawViewWithSelection(org.fife.ui.rsyntaxtextarea.TokenPainter painter, java.awt.Graphics2D g, java.awt.Rectangle r, javax.swing.text.View view, int fontHeight, int y, int selStart, int selEnd)` Draws a single view (i.e., a line of text for a wrapped view), wrapping the text onto multiple lines if necessary.
    `java.awt.Shape` | `getChildAllocation(int index, java.awt.Shape a)` Fetches the allocation for the given child view.
    `java.awt.Shape` | `getChildAllocationImpl(int line, java.awt.Shape a)` Fetches the allocation for the given child view to render into.
    `float` | `getMaximumSpan(int axis)` Determines the maximum span for this view along an axis.
    `float` | `getMinimumSpan(int axis)` Determines the minimum span for this view along an axis.
    `float` | `getPreferredSpan(int axis)` Determines the preferred span for this view along an axis.
    `protected int` | `getTabSize()` Returns the tab size set for the document, defaulting to 5.
    `protected javax.swing.text.View` | `getViewAtPoint(int x, int y, java.awt.Rectangle alloc)` Overridden to allow for folded regions.
    `void` | `insertUpdate(javax.swing.event.DocumentEvent changes, java.awt.Shape a, javax.swing.text.ViewFactory f)` Gives notification that something was inserted into the document in a location that this view is responsible for.
    `protected void` | `loadChildren(javax.swing.text.ViewFactory f)` Loads all of the children to initialize the view.
    `java.awt.Shape` | `modelToView(int p0, javax.swing.text.Position.Bias b0, int p1, javax.swing.text.Position.Bias b1, java.awt.Shape a)` Provides a mapping, for a given region, from the document model coordinate space to the view coordinate space.
    `java.awt.Shape` | `modelToView(int pos, java.awt.Shape a, javax.swing.text.Position.Bias b)`
    `float` | `nextTabStop(float x, int tabOffset)` Returns the next tab stop position after a given reference position.
    `void` | `paint(java.awt.Graphics g, java.awt.Shape a)` Paints the word-wrapped text.
    `void` | `removeUpdate(javax.swing.event.DocumentEvent changes, java.awt.Shape a, javax.swing.text.ViewFactory f)` Gives notification that something was removed from the document in a location that this view is responsible for.
    `void` | `setSize(float width, float height)` Sets the size of the view.
    `int` | `viewToModel(float x, float y, java.awt.Shape a, javax.swing.text.Position.Bias[] bias)`
    `int` | `yForLine(java.awt.Rectangle alloc, int line)` Returns the y-coordinate of the specified line.
    `int` | `yForLineContaining(java.awt.Rectangle alloc, int offs)` Returns the y-coordinate of the line containing a specified offset.

    - ### Methods inherited from class javax.swing.text.BoxView

      `baselineLayout, baselineRequirements, calculateMajorAxisRequirements, calculateMinorAxisRequirements, childAllocation, flipEastAndWestAtEnds, forwardUpdate, getAlignment, getAxis, getHeight, getOffset, getResizeWeight, getSpan, getWidth, isAfter, isAllocationValid, isBefore, isLayoutValid, layout, layoutChanged, layoutMajorAxis, layoutMinorAxis, paintChild, preferenceChanged, replace, setAxis`

    - ### Methods inherited from class javax.swing.text.CompositeView

      `getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, getViewIndexAtPosition, setInsets, setParagraphInsets, setParent`

    - ### Methods inherited from class javax.swing.text.View

      `append, breakView, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, isVisible, modelToView, remove, removeAll, updateChildren, updateLayout, viewToModel`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WrappedSyntaxView

          public WrappedSyntaxView(javax.swing.text.Element elem)

      Creates a new WrappedSyntaxView. Lines will be wrapped on character boundaries.
      Parameters:
        `elem` - the element underlying the view

  - ### Method Detail

    - #### calculateBreakPosition

          protected int calculateBreakPosition(int p0,
                                   Token tokenList,
                                   float x0)

      This is called by the nested wrapped line views to determine the break location. This can be reimplemented to alter the breaking behavior. It will either break at word or character boundaries depending upon the break argument given at construction.

    - #### changedUpdate

          public void changedUpdate(javax.swing.event.DocumentEvent e,
                           java.awt.Shape a,
                           javax.swing.text.ViewFactory f)

      Gives notification from the document that attributes were changed in a location that this view is responsible for.
      Overrides:
        `changedUpdate` in class `javax.swing.text.View`
      Parameters:
        `e` - the change information from the associated document
        `a` - the current allocation of the view
        `f` - the factory to use to rebuild if the view has children
      See Also:
        `View.changedUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

    - #### drawView

          protected void drawView(org.fife.ui.rsyntaxtextarea.TokenPainter painter,
                      java.awt.Graphics2D g,
                      java.awt.Rectangle r,
                      javax.swing.text.View view,
                      int fontHeight,
                      int y,
                      int line)

      Draws a single view (i.e., a line of text for a wrapped view), wrapping the text onto multiple lines if necessary.
      Parameters:
        `painter` - The painter to use to render tokens.
        `g` - The graphics context in which to paint.
        `r` - The rectangle in which to paint.
        `view` - The `View` to paint.
        `fontHeight` - The height of the font being used.
        `y` - The y-coordinate at which to begin painting.

    - #### drawViewWithSelection

          protected void drawViewWithSelection(org.fife.ui.rsyntaxtextarea.TokenPainter painter,
                                   java.awt.Graphics2D g,
                                   java.awt.Rectangle r,
                                   javax.swing.text.View view,
                                   int fontHeight,
                                   int y,
                                   int selStart,
                                   int selEnd)

      Draws a single view (i.e., a line of text for a wrapped view), wrapping the text onto multiple lines if necessary. Any selected text is rendered with the editor's "selected text" color.
      Parameters:
        `painter` - The painter to use to render tokens.
        `g` - The graphics context in which to paint.
        `r` - The rectangle in which to paint.
        `view` - The `View` to paint.
        `fontHeight` - The height of the font being used.
        `y` - The y-coordinate at which to begin painting.
        `selStart` - The start of the selection.
        `selEnd` - The end of the selection.

    - #### getChildAllocation

          public java.awt.Shape getChildAllocation(int index,
                                          java.awt.Shape a)

      Fetches the allocation for the given child view.

      Overridden to account for code folding.

      Overrides:
        `getChildAllocation` in class `javax.swing.text.BoxView`
      Parameters:
        `index` - The index of the child, >= 0 &&< getViewCount().
        `a` - The allocation to this view
      Returns:
        The allocation to the child; or `null` if `a` is `null`; or `null` if the layout is invalid

    - #### getChildAllocationImpl

          public java.awt.Shape getChildAllocationImpl(int line,
                                              java.awt.Shape a)

      Fetches the allocation for the given child view to render into.

      Overridden to account for lines hidden by collapsed folded regions.

      Parameters:
        `line` - The index of the child, >= 0 &&< getViewCount()
        `a` - The allocation to this view
      Returns:
        The allocation to the child

    - #### getMaximumSpan

          public float getMaximumSpan(int axis)

      Determines the maximum span for this view along an axis. This is implemented to provide the superclass behavior after first making sure that the current font metrics are cached (for the nested lines which use the metrics to determine the height of the potentially wrapped lines).
      Overrides:
        `getMaximumSpan` in class `javax.swing.text.BoxView`
      Parameters:
        `axis` - may be either View.X_AXIS or View.Y_AXIS
      Returns:
        the span the view would like to be rendered into. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
      See Also:
        `View.getMaximumSpan(int)`

    - #### getMinimumSpan

          public float getMinimumSpan(int axis)

      Determines the minimum span for this view along an axis. This is implemented to provide the superclass behavior after first making sure that the current font metrics are cached (for the nested lines which use the metrics to determine the height of the potentially wrapped lines).
      Overrides:
        `getMinimumSpan` in class `javax.swing.text.BoxView`
      Parameters:
        `axis` - may be either View.X_AXIS or View.Y_AXIS
      Returns:
        the span the view would like to be rendered into. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
      See Also:
        `View.getMinimumSpan(int)`

    - #### getPreferredSpan

          public float getPreferredSpan(int axis)

      Determines the preferred span for this view along an axis. This is implemented to provide the superclass behavior after first making sure that the current font metrics are cached (for the nested lines which use the metrics to determine the height of the potentially wrapped lines).
      Overrides:
        `getPreferredSpan` in class `javax.swing.text.BoxView`
      Parameters:
        `axis` - may be either View.X_AXIS or View.Y_AXIS
      Returns:
        the span the view would like to be rendered into. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
      See Also:
        `View.getPreferredSpan(int)`

    - #### getTabSize

          protected int getTabSize()

      Returns the tab size set for the document, defaulting to 5.
      Returns:
        the tab size

    - #### getViewAtPoint

          protected javax.swing.text.View getViewAtPoint(int x,
                                             int y,
                                             java.awt.Rectangle alloc)

      Overridden to allow for folded regions.
      Overrides:
        `getViewAtPoint` in class `javax.swing.text.BoxView`

    - #### insertUpdate

          public void insertUpdate(javax.swing.event.DocumentEvent changes,
                          java.awt.Shape a,
                          javax.swing.text.ViewFactory f)

      Gives notification that something was inserted into the document in a location that this view is responsible for. This is implemented to simply update the children.
      Overrides:
        `insertUpdate` in class `javax.swing.text.View`
      Parameters:
        `changes` - The change information from the associated document.
        `a` - the current allocation of the view
        `f` - the factory to use to rebuild if the view has children
      See Also:
        `View.insertUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

    - #### loadChildren

          protected void loadChildren(javax.swing.text.ViewFactory f)

      Loads all of the children to initialize the view. This is called by the `setParent` method. Subclasses can re-implement this to initialize their child views in a different manner. The default implementation creates a child view for each child element.
      Overrides:
        `loadChildren` in class `javax.swing.text.CompositeView`
      Parameters:
        `f` - the view factory

    - #### modelToView

          public java.awt.Shape modelToView(int pos,
                                   java.awt.Shape a,
                                   javax.swing.text.Position.Bias b)
                                     throws javax.swing.text.BadLocationException

      Overrides:
        `modelToView` in class `javax.swing.text.BoxView`
      Throws:
        `javax.swing.text.BadLocationException`

    - #### modelToView

          public java.awt.Shape modelToView(int p0,
                                   javax.swing.text.Position.Bias b0,
                                   int p1,
                                   javax.swing.text.Position.Bias b1,
                                   java.awt.Shape a)
                                     throws javax.swing.text.BadLocationException

      Provides a mapping, for a given region, from the document model coordinate space to the view coordinate space. The specified region is created as a union of the first and last character positions.

      This is implemented to subtract the width of the second character, as this view's `modelToView` actually returns the width of the character instead of "1" or "0" like the View implementations in `javax.swing.text`. Thus, if we don't override this method, the `View` implementation will return one character's width too much for its consumers (implementations of `javax.swing.text.Highlighter`).

      Overrides:
        `modelToView` in class `javax.swing.text.CompositeView`
      Parameters:
        `p0` - the position of the first character (>=0)
        `b0` - The bias of the first character position, toward the previous character or the next character represented by the offset, in case the position is a boundary of two views; `b0` will have one of these values:
        - `Position.Bias.Forward`
        - `Position.Bias.Backward`
        `p1` - the position of the last character (>=0)
        `b1` - the bias for the second character position, defined one of the legal values shown above
        `a` - the area of the view, which encompasses the requested region
      Returns:
        the bounding box which is a union of the region specified by the first and last character positions
      Throws:
        `javax.swing.text.BadLocationException` - if the given position does not represent a valid location in the associated document
        `java.lang.IllegalArgumentException` - if `b0` or `b1` are not one of the legal `Position.Bias` values listed above
      See Also:
        `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

    - #### nextTabStop

          public float nextTabStop(float x,
                          int tabOffset)

      Returns the next tab stop position after a given reference position. This implementation does not support things like centering so it ignores the tabOffset argument.
      Specified by:
        `nextTabStop` in interface `javax.swing.text.TabExpander`
      Parameters:
        `x` - the current position >= 0
        `tabOffset` - the position within the text stream that the tab occurred at >= 0.
      Returns:
        the tab stop, measured in points >= 0

    - #### paint

          public void paint(java.awt.Graphics g,
                   java.awt.Shape a)

      Paints the word-wrapped text.
      Overrides:
        `paint` in class `javax.swing.text.BoxView`
      Parameters:
        `g` - The graphics context in which to paint.
        `a` - The shape (usually a rectangle) in which to paint.

    - #### removeUpdate

          public void removeUpdate(javax.swing.event.DocumentEvent changes,
                          java.awt.Shape a,
                          javax.swing.text.ViewFactory f)

      Gives notification that something was removed from the document in a location that this view is responsible for. This is implemented to simply update the children.
      Overrides:
        `removeUpdate` in class `javax.swing.text.View`
      Parameters:
        `changes` - The change information from the associated document.
        `a` - the current allocation of the view
        `f` - the factory to use to rebuild if the view has children
      See Also:
        `View.removeUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

    - #### setSize

          public void setSize(float width,
                     float height)

      Sets the size of the view. This should cause layout of the view along the given axis, if it has any layout duties.
      Overrides:
        `setSize` in class `javax.swing.text.BoxView`
      Parameters:
        `width` - the width >= 0
        `height` - the height >= 0

    - #### viewToModel

          public int viewToModel(float x,
                        float y,
                        java.awt.Shape a,
                        javax.swing.text.Position.Bias[] bias)

      Overrides:
        `viewToModel` in class `javax.swing.text.BoxView`

    - #### yForLine

          public int yForLine(java.awt.Rectangle alloc,
                     int line)
                       throws javax.swing.text.BadLocationException

      Returns the y-coordinate of the specified line.

      This method is quicker than using traditional `modelToView(int)` calls, as the entire bounding box isn't computed.

      Parameters:
        `alloc` - The area the text area can render into.
        `line` - The line number.
      Returns:
        The y-coordinate of the top of the line, or `-1` if this text area doesn't yet have a positive size or the line is hidden (i.e. from folding).
      Throws:
        `javax.swing.text.BadLocationException` - If `line` isn't a valid line number for this document.

    - #### yForLineContaining

          public int yForLineContaining(java.awt.Rectangle alloc,
                               int offs)
                                 throws javax.swing.text.BadLocationException

      Returns the y-coordinate of the line containing a specified offset.

      This method is quicker than using traditional `modelToView(int)` calls, as the entire bounding box isn't computed.

      Parameters:
        `alloc` - The area the text area can render into.
        `offs` - The offset info the document.
      Returns:
        The y-coordinate of the top of the offset, or `-1` if this text area doesn't yet have a positive size or the line is hidden (i.e. from folding).
      Throws:
        `javax.swing.text.BadLocationException` - If `offs` isn't a valid offset into the document.